from FXCMRestWarpper import param
from FXCMRestWarpper.requsest_decor import req
from FXCMRestWarpper import setting
from FXCMRestWarpper.auth import authentication
import csv
import json


class candledata:
    def __init__(self,auth):
        self.auth = auth
    def getdata(self, num, instrumnet_id, period):
        num = num
        instrumnet_id = instrumnet_id.__str__()
        period = period
        params = param.CandleParam().getCandleParam()
        params['num'] = num
        get = req.GetRequset(self.auth)
        rep = get.request(setting.TRADING, "/candles/" + instrumnet_id + "/" + period, params)
        print(rep)
        return rep['candles']

    def outputcsv(self, data):
        f = csv.writer(open("EURJPY.csv", "w+"))
        f.writerow(["timestamp", "bidopen", "bidclose", "bidhigh", "bidlow", "askopen", "askclose", "askhigh", "asklow",
                    "tickqty"])
        f.writerows(data)


if __name__ == '__main__':
    test = authentication.Authentication()
    candledata = candledata(test)
    data = candledata.getdata(4015, 1, 'D1')
    print("number of candle downloaded = " + (str(len(data))))
    candledata.outputcsv(data)
