import requests
from .. import setting
from FXCMRestWarpper.auth import authentication
# TODO add header
class GetRequset:
    def __init__(self,auth):
        self.auth = auth
    def request(self,endpoint,uri,params):
        bearToken = 'Bearer {0}{1}'.format(self.auth.getSocketid(),setting.AUTH_TOKEN)
        hed = { 'Authorization': bearToken,
                'User-Agent': 'request',
                'Accept': 'application/json',
                'Content-Type': 'application/x-www-form-urlencoded'}
        print(hed)
        response = requests.get(endpoint + uri,params=params,headers=hed)
        print("Request URL for method", "GET", ": \t", response.url)
        print(response)
        return response.json()

class PatchRequset:
    def __init__(self,auth):
        self.auth = auth
    def request(self,endpoint,uri,params):
        bearToken = 'Bearer {0}{1}'.format(self.auth.getSocketid(), setting.AUTH_TOKEN)
        hed = {'Authorization': bearToken}
        response = requests.patch(endpoint + uri, data=params,headers = hed)
        print("Request URL for method", "PATCH", ": \t", response.url)
        return response.json()

class PostRequset:
    def __init__(self,auth):
        self.auth = auth
    def request(self,endpoint,uri,params):
        bearToken = 'Bearer {0}{1}'.format(self.auth.getSocketid(),setting.AUTH_TOKEN)
        hed = {'Authorization': bearToken}
        response = requests.post(endpoint + uri, data=params,headers = hed)
        print("Request URL for method", "Post", ": \t", response.url)
        print(response)
        return response.json()

class DeleteRequset:
    def __init__(self,auth):
        self.auth = auth
    def request(self,endpoint,uri,params):
        bearToken = 'Bearer {0}{1}'.format(self.auth.getSocketid(), setting.AUTH_TOKEN)
        hed = {'Authorization': bearToken}
        response = requests.delete(endpoint + uri, data=params,headers = hed)
        print("Request URL for method", "Post", ": \t", response.url)
        return response.json()
