from FXCMRestWarpper import param
from FXCMRestWarpper.requsest_decor import req
from FXCMRestWarpper import setting
from FXCMRestWarpper.auth import authentication
class Trade():
    def __init__(
        self, auth
    ):
        self.auth = auth

    def openTrade(self, account_id, symbol, is_buy,rate, amount,stop=None,
                  trailing_step=None, limit=None, is_in_pips=1, at_market=None,
                  order_type='AtMarket', time_in_force='IOC'):
        params = param.OrderParam().getOpenTradeParam()
        params['account_id'] = account_id
        params['symbol'] = symbol
        params['is_buy'] = is_buy
        params['rate'] = rate
        params['amount'] = amount
        params['stop'] = stop
        params['trailing_step'] = trailing_step
        params['limit'] = limit
        params['is_in_pips'] = is_in_pips
        params['at_market'] = at_market
        params['order_type'] = order_type
        params['time_in_force'] = time_in_force
        post = req.PostRequset(self.auth)
        reps = post.request(setting.TRADING,"/trading/open_trade",params)
        return reps

    def closeTrade(self,trade_id,rate,amount,at_market,order_type,time_in_force):
        params = param.OrderParam().getCloseTradeParam()
        params['trade_id'] = trade_id
        params['rate'] = rate
        params['amount'] = amount
        params['at_market'] = at_market
        params['order_type'] = order_type
        params['time_in_force'] = time_in_force
        post = req.PostRequset(self.auth)
        rep = post.request(setting.TRADING,"/trading/close_trade",params)
        return rep

if __name__ == '__main__':
    test = authentication.Authentication()
    # this part is getting the accountID
    par = {'models': "Account"}
    get = req.GetRequset(test)
    rep = get.request(setting.TRADING,"/trading/get_model",par)
    print(rep)
    # init trade
    test1 = Trade(test)
    print(test1.openTrade(rep['accounts'][0]['accountId'], 'EUR/USD', 0,
                          1.7810, 1, None, None, None, 1, None,
                          'AtMarket', 'IOC',))
