from FXCMRestWarpper import param
from FXCMRestWarpper.requsest_decor import req
from FXCMRestWarpper import setting
from FXCMRestWarpper.auth import authentication
import datetime


class snapshot:
    def __init__(
        self,auth
    ):
        self.auth = auth

    def getsnapshot(self, reqlist):
        params = param.TablesParam().getSnapshotParam()
        params['models'] = reqlist
        get = req.GetRequset(self.auth)
        rep = get.request(setting.TRADING, "/trading/get_model", params)
        return rep

    def timeparser(self, time):
        month = time[:2]
        day = time[2:4]
        year = time[4:8]
        hour = time[8:10]
        mins = time[10:12]
        sec = time[-2:]
        return datetime.datetime(int(year), int(month), int(day), int(hour), int(mins), int(sec))

    def check_trade_info(self, rep, exetime):
        """
        assume the latest trade are on the first element
        form observation the latest position always on pos 0
        so the logic are comparing only pos 0
        """

        if rep['closed_positions'][0]['closeTime'] is None:
            print("no closed pos, using latest open pos")
            return rep['open_positions'][0]['close']
        elif rep['open_positions'][0]['time'] is None:
            print("no open pos, using latest closed pos")
            return rep['closed_positions'][0]['close']
        elif self.timeparser(rep['closed_positions'][0]['closeTime']) < self.timeparser(rep['open_positions'][0]['time']) < exetime:
            print("using open pos")
            return rep['open_positions'][0]['close']
        elif self.timeparser(rep['closed_positions'][0]['closeTime']) > self.timeparser(rep['open_positions'][0]['time']) < exetime:
            print("using closed pos")
            return rep['closed_positions'][0]['close']
        else:
            raise TypeError
if __name__ == '__main__':
    test = authentication.Authentication()
    snap = snapshot(test)
    mylist = ['ClosedPosition', 'OpenPosition']
    print(snap.check_trade_info(snap.getsnapshot(mylist),datetime.datetime.now()))
    #print(snap.timeparser(snap.getsnapshot(mylist)['closed_positions'][0]['closeTime']))
    #print(datetime.datetime.now(tz=datetime.timezone.utc))
